#include <idc.idc>

#define EAX_CMP_CC "80 38 CC"
#define EBX_CMP_CC "80 3B CC"
#define ECX_CMP_CC "80 39 CC"
#define EDX_CMP_CC "80 3A CC"
#define ESI_CMP_CC "80 3E CC"
#define EDI_CMP_CC "80 3F CC"
#define EBP_CMP_CC "80 7D 00 CC"
#define ESP_CMP_CC "80 3C 24 CC"

static main(void)
{
  auto ea, count, fp;
  ea = 0xde2000;
  count = 0;
  fp = fopen("cmp_CC.txt", "w");
  if ( fp == 0 )
  {
    Message("Error opening fp\n");
    return;
  }
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, EAX_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }
     
    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, EBX_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, ECX_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, EDX_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, ESI_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, EDI_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, EBP_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  ea = 0xde2000;
  while ( 1 )
  {
    ea = FindBinary(ea,SEARCH_DOWN|SEARCH_NEXT, ESP_CMP_CC);
    if ( ea == BADADDR )
      break;
    Message("Found %x\n", ea); count++;
    if ( fprintf(fp, "0x%x\n", ea) != 0 )
      { Message("Error while writing fp!!\n"); break; }

    if ( MakeCode(ea - 0x0E) == 0 )
      Message("MakeCode failed at %x\n", ea);
  }

  Message("Count = %u\n", count);
  fclose(fp);
  Message("Done CMP_CC\n");


}