/*
 * XOR stdin to stdout
 *
 * Dino Dai Zovi <ghandi@mindless.com>
 */

#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char* argv[])
{
    unsigned char b;
    unsigned char x;

    x = strtoul(argv[1], NULL, 16);
    
    while (read(0, &b, 1) > 0) {
        b ^= x;
        write(1, &b, 1);
    }

    return 0;
}
